//Mandelbulb mit Mesh-Tracing und Multithreading
//Drehung um x-Achse: Taste 'x'   Drehung um y-Achse: Taste 'y'  Drehung um z-Achse: Taste 'z'
//Wechsel zwischen farbig und s/w:  Taste 'g'
//Taste 'f' : Änderung der Farbe
//Taste 'F' : Farbdynamik ändern
//Taste '+' erhöht den Exponent um 1
//Taste '-' erniedrigt den Exponent um 1
//Punkte auf den Parallelstrahlen starten an der Projektionsfläche ABCD
//Jedem Startpunkt eines Strahls wird, abhängig vom Verlauf, ein Pixel zugeordent
//Es wird daher ein zweidimensionales Bild erzeugt
//Programmieren mit Computergrafik. Deussen, Ningelgen

int aufloesung=800;// = width!
int aT =10;//Anzahl Threads - aT muss Teiler sein von auflöesung!
int abstandScreen;
int anteil;
float anteilErledigt11 ;//misst den Fortschritt in Thread 11
float laenge;
int   m = 8; //Exponent
//Screen:
float[][] A = new float[aT][3];
float[][] B = new float[aT][3];
float[][] C = new float[aT][3];
float[][] D = new float[aT][3];
ArrayList<float[]>[] startPunkte = new ArrayList[aT];
ArrayList<float[]>[] bildPunkte = new ArrayList[aT];
ArrayList<float[]>[] raumBildPunkte = new ArrayList[aT];
float[][]raumBildPunkt = new float[aT][aT];;
float wh;;//Abstand untere-obere Grenze
float alZ ;//Drehwinkel z-Achse
float alY ;//Drehwinkel y-Achse
float alX ;//Drehwinkel x-Achse
float fak ;//Umrechnungsfaktor von Pixel in Raum
float[] abstand = new float[aT];//...vom Ursprung
float fVariante ;
float fVerschiebung;
float helligkeit;
PImage bild;
boolean farbigZeichnen = true;
boolean nextStep = true;
ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
float[]tempD = new float[aT];//verwendet für hell-dunkel
float[]tempF = new float[aT];//verwendet für Farbe
float[] grauWerte = new float[aufloesung*aufloesung];
float[] farbWerte = new float[aufloesung*aufloesung];
float[][] raumENV = new float[aT][3];
//-------------------------------------------------
void setup(){
  size(800,800,P2D);
  colorMode(HSB);
  wh = 2.3;//max Ausdehnung in allen Achsen (Würfel Kantenlänge 8, Mittelpunkt Ursprung (Zoom: wh=0.7)
  fak = wh/aufloesung;//enstspricht Entfernung zwischen den einzelnen Pixeln
  anteil = aufloesung/aT; //Anteil für jeden Thread
  alX = 0; alY = PI/2; alZ = 0 ;
  abstandScreen = 400;  
  fVariante = 290;
  fVerschiebung = 80;
  initialisieren();
  starten();
}
//-----------------------------------------------------------
void draw(){  
  if(nextStep){  
    loadPixels();
    PImage bild = createImage(width,height,RGB);
    
    if(farbigZeichnen){
       for (int i = 0; i < aufloesung*aufloesung; i++) {  
           helligkeit = 1.5*grauWerte[i];
           if(helligkeit > 3 && helligkeit < 50) helligkeit = 120;
           bild.pixels[i] =  color(farbWerte[i],255,helligkeit);    
       }
    }else{
       for (int i = 0; i < aufloesung*aufloesung; i++) {  
        
            bild.pixels[i] =  color(grauWerte[i]);         
       }
     }  
     println();//Leerzeile
     println("Kantenlänge des zu untersuchenden Bereichs (Würfel mit O als Zentrum): "+wh); 
     println("Ein Pixel enspricht der Länge: "+fak," Abstand Screen: "+abstandScreen);
     println("Time: "+second());//bei distEst 0.3*  : 405, bei 0.5* : 84 => mehr Kontrast bei 0.3
     println("Winkel Drehung y-Achse: "+alY+ " x-Achse: "+ alX+ " z-Achse: "+ alZ);
     println("Farbvariante: "+fVariante + " Farbverschiebung: "+fVerschiebung);  
    
     image(bild,0,0);
     save("bild.png");  
     nextStep=false;
     System.gc();
    }
}
//----------------------------------------------------------------------
void starten(){   
  //Platz für Erweiterungen
  multiThreadsStarten();  
}
//--------------------------------------------------------------------------
void multiThreadsStarten(){
   workers.clear();
   for (int i=0; i<aT; i++)
    {
      workers.add(new WorkThread(i)); 
    }
    for (WorkThread worker : workers) {  
      while (worker.running)
      {       
        try{
        Thread.sleep(10);  
        }catch (Exception e) {  }  ;                
      }
    }
    for(int n =0; n<aT; n++){
      tempD = workers.get(n).pixValuesGray[n];  
      tempF = workers.get(n).pixValuesColor[n];
      for(int i = 0; i<aufloesung*anteil;i++){
            grauWerte[i+n*aufloesung*anteil]=tempD[i];
            farbWerte[i+n*aufloesung*anteil]=tempF[i];
      }
    }
}
//------------------------------------------------------------
float[] matrixMalvector(float[][] M, float[] V){
    float[] ergebnisV = new float[3];
      for(int i=0;i<3;i++){ 
        ergebnisV[i] = M[i][0]*V[0]+M[i][1]*V[1]+M[i][2]*V[2];      
      }
    return ergebnisV;
}
//---------------------------------------------------------------------
float[] drehenZ(int n, float alpha, float[] Vector){
    alZ = alpha;
    float[][] Dz =  { {cos(alZ)  , -sin(alZ)   ,   0   },
                      {sin(alZ)  ,  cos(alZ)   ,   0   },
                      {    0     ,    0        ,   1   }};
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dz,Vector);
    return gedrehterV;    
}
//---------------------------------------------------------------------
float[] drehenY(int n, float alpha, float[] Vector){
    alY = alpha;
    float[][] Dy =  { {cos(alY) ,   0   ,sin(alY)},
                      {  0      ,   1   ,   0    },
                      {-sin(alY),   0   , cos(alY)}   };
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dy,Vector);
    return gedrehterV;    
}
//---------------------------------------------------------------------
float[] drehenX(int n, float alpha, float[] Vector){
    alX = alpha;
      float[][] Dx =  {{ 1     ,      0      ,     0     },
                      {  0     ,    cos(alX) ,  -sin(alX)},
                      {  0     ,    sin(alX) ,   cos(alX)}};
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dx,Vector);
    return gedrehterV;    
}
//-----------------------------------------------------------------------------------
void gedrehtePunkteBerechnen(int n,float winkelY, float winkelX,  float winkelZ){
  bildPunkte[n] = new ArrayList<float[]>();raumBildPunkte[n] = new ArrayList<float[]>();
  float[] richtungEV ={-1,0,0};
  alY = winkelY;alX = winkelX ;alZ = winkelZ;
  
  raumENV[n] = drehenY(n,alY,richtungEV); 
  raumENV[n] = drehenX(n,alX,raumENV[n]);
  raumENV[n] = drehenZ(n,alZ,raumENV[n]);
  
  for(int j=0;j<aufloesung*aufloesung/aT; j++){ 
    float[] bP =drehenY(n,alY,startPunkte[n].get(j));bP = drehenX(n,alX,bP); bP = drehenZ(n,alZ,bP);
    float[] raumBP = {bP[0]*fak,bP[1]*fak,bP[2]*fak};   
    bildPunkte[n].add(bP);raumBildPunkte[n].add(raumBP);
  }
}
//---------------------------------------------------------------------
void startPunkteBerechnen(int n, int abstandScreen){
  //abstandScreen, da konstant, müsste hier nicht übergeben werden. 
  //Ist für Folgeprogramme hier schon mal eingeführt
  startPunkte[n] = new ArrayList<float[]>();
  for(int i=n*aufloesung/aT; i<(n+1)*aufloesung/aT; i++){
     for(int j=0;j<aufloesung; j++){     
       float[] p = {-abstandScreen,-aufloesung/2+j,-aufloesung/2+i};    
       startPunkte[n].add(p);
     }
  } 
}
//---------------------------------------------------------------------------
void initialisieren(){
 
    for(int n = 0; n < aT; n++){
         A[n][0]=-abstandScreen;A[n][1]=-aufloesung/2;A[n][2]=-aufloesung/2;
    }  
    for(int n = 0; n < aT; n++){
         B[n][0]=-abstandScreen;B[n][1]=-aufloesung/2;B[n][2]=-aufloesung/2;
    }  
    for(int n = 0; n < aT; n++){
         C[n][0]=-abstandScreen;C[n][1]=-aufloesung/2;C[n][2]=-aufloesung/2;
    }  
    for(int n = 0; n < aT; n++){
         D[n][0]=-abstandScreen;D[n][1]=-aufloesung/2;D[n][2]=-aufloesung/2;
    }  
 
    for (int i = 0; i < aT; i++) {
              startPunkte[i] = new ArrayList<float[]>();
    }
    for (int i = 0; i < aT; i++) {
              bildPunkte[i] = new ArrayList<float[]>();
    }
    for (int i = 0; i < aT; i++) {
              raumBildPunkte[i] = new ArrayList<float[]>();
    }
}
//-------------------------------------------------------------------------
void keyPressed(){
  
  if (key == 'z') {//Drehung um z-Achse
    alZ = alZ + PI/3;    
    initialisieren();    
    nextStep = true;
    starten();    
  }
  if (key == 'y') {//Drehung um y-Achse
    alY = alY + PI/8;    
    initialisieren();    
    nextStep = true;
    starten();    
  }
  if (key == 'x') {//Drehung um x-Achse
    alX = alX + PI/6;   
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == 'g') {//farbig/grau Zeichnen
    farbigZeichnen = !farbigZeichnen;
    initialisieren();    
    nextStep = true;
    starten();
  }
  if (key == 'f') {//Farbe wechseln
    fVerschiebung = random(60,120);
    initialisieren();    
    nextStep = true;
    starten();
  }
  if (key == 'F') {//Farbdynamik ändern
    fVariante = random(160,460);
    initialisieren();    
    nextStep = true;
    starten();
  }
  if (key == '+') {//Exponent um 1 erhöhen
    m++;
    initialisieren();    
    nextStep = true;
    starten();
  }
  if (key == '-') {//Exponent um 1 erhöhen
    m--;
    initialisieren();    
    nextStep = true;
    starten();
  }
    
}
//-------------------------------------------------------------------
Spherical spherical(float x, float y, float z) {
  float r = sqrt(x*x + y*y + z*z);
  float theta = atan2( sqrt(x*x+y*y), z);
  float phi = atan2(y, x);
  return new Spherical(r, theta, phi);
}

class Spherical {
  float r, theta, phi;
  Spherical(float r, float theta, float phi) {
    this.r = r;
    this.theta = theta;
    this.phi = phi;
  }
}
//////////////////////////////////////////////////////////////////////////////////
class WorkThread implements Runnable {

  protected boolean running = true;
  private int nummer;
   
  ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
  
  float[][] pixValuesGray  =  new float[aT][aufloesung*anteil];//for every Thread
  float[][] pixValuesColor =  new float[aT][aufloesung*anteil];
       
  public WorkThread (int nummer){
    this.nummer = nummer;
    Thread thread = new Thread(this);
    thread.start();
  }
  public void run() {       
      this.running = true;
      println("Die interne Threadnummer ist: " 
       + Thread.currentThread().getId() + ", Eigene Threadnummer: " + nummer);
       
        switch(nummer){ 
          
        case 0:pixelBerechnen( 0); break;              
        case 1:pixelBerechnen( 1); break;                
        case 2:pixelBerechnen( 2); break;                 
        case 3:pixelBerechnen( 3); break;          
        case 4:pixelBerechnen( 4); break;            
        case 5:pixelBerechnen( 5); break;        
        case 6:pixelBerechnen( 6); break;       
        case 7:pixelBerechnen( 7); break;            
        case 8:pixelBerechnen( 8); break;       
        case 9:pixelBerechnen( 9); break;          
        case 10:pixelBerechnen(10); break;            
        case 11:pixelBerechnen(11); break;    
        case 12:pixelBerechnen(12); break;            
        case 13:pixelBerechnen(13); break;       
        case 14:pixelBerechnen(14); break;          
        case 15:pixelBerechnen(15); break;            
                        
    }
    println("Threads mit Nummer "+nummer+" ist fertig!");   
    this.running = false;
  }
  
 void pixelBerechnen(int n){//if und else if nur einmal => Beschleunigung
     startPunkteBerechnen(n,abstandScreen);
     gedrehtePunkteBerechnen(n,alY,alX,alZ);   
     float max=0;float min=400;
     float maxAb=0;float minAb=2;
     abstandScreen = 400;  
     for(int j = 0; j<aufloesung*aufloesung/aT;j++){
          raumBildPunkt[n] = raumBildPunkte[n].get(j);           
          float[] rBP =  raumBildPunkt[n];
          int k = 350;        
          while(istDivergent(rBP) && k > 0){
            raumBildPunkt[n][0] = raumBildPunkt[n][0] -0.009*raumENV[n][0];    
            raumBildPunkt[n][1] = raumBildPunkt[n][1] -0.009*raumENV[n][1];    
            raumBildPunkt[n][2] = raumBildPunkt[n][2] -0.009*raumENV[n][2];  
            rBP[0] = raumBildPunkt[n][0];
            rBP[1] = raumBildPunkt[n][1];
            rBP[2] = raumBildPunkt[n][2];
            k--; 
         }
      abstand[n] = sqrt(sq(raumBildPunkt[n][0])+sq(raumBildPunkt[n][1])+sq(raumBildPunkt[n][2]));
     
      pixValuesColor[n][j] = (fVariante*abstand[n]*abstand[n]+fVerschiebung)%256; 
      if(abstand[n]>maxAb) maxAb = abstand[n];//Max-Abstand vom Ursprung
      if(abstand[n]<minAb) minAb = abstand[n];//Min-Abstand vom Ursprung
        
      float grauW =k*abstand[n];//Multiplikation mit abstand[n] erhöht den Kontrast
      if(k!=0){
        if(grauW > max)max =grauW;  //Max-Entfernung von der Screen
        if(grauW < min)min =grauW;  //Min-Entfernung von der Screen
      }
      pixValuesGray[n][j] = map(grauW,155,375,0,255);  //hier min=155, max=375      
      if(n==4 && j%1000==0){//Info über Rechenfortschritt
      }     
     }
     println();
     float entfMin = fak*min; float entfMax = fak*max;
     println("Entfernung von der Screen: "+" Min: "+entfMin+" Max: "+entfMax);
     println("Schritte ab Screen: Min: "+min + " Max: " +max);
     println("Abstand vom Ursprung: Min: "+minAb + " Max: "+maxAb);
 }//end of pixelBerechnen  
//----------------------------------------------------------------------
 boolean istDivergent(float[] rBP){
    float x = rBP[0];
    float y = rBP[1];
    float z = rBP[2];
    float b;
    
    int   maxiterations = 8;
    boolean divergent = false;
    PVector zeta = new PVector(0, 0, 0);
    int iteration = 0;
       
    while (true) {
         // int k = 0;
          Spherical c = spherical(zeta.x, zeta.y, zeta.z);
          float newx = pow(c.r, m) * sin(c.theta*m) * cos(c.phi*m);
          float newy = pow(c.r, m) * sin(c.theta*m) * sin(c.phi*m);
          float newz = pow(c.r, m) * cos(c.theta*m);
          zeta.x = newx + x;
          zeta.y = newy + y;
          zeta.z = newz + z;          
          b = c.r;
          if(b > 1.4){
            divergent = true;
            break;            
          }    
          if(iteration >6){
            divergent = false;
            break;            
          }
           iteration++;          
         
     }
    // if(n==6) print(divergent,iteration+"  ");
   return divergent;
 }
//-------------------------------------------------------------------  

}//end of WorkThread
